# coding: utf-8

"""

    Copyright (c) 2021 Aspose.BarCode for Cloud

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all
 copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 SOFTWARE.

"""


import pprint
import re  # noqa: F401

import six


class StructuredAppend(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {"sequence_indicator": "int", "total_count": "int", "parity_byte": "int"}

    attribute_map = {
        "sequence_indicator": "SequenceIndicator",
        "total_count": "TotalCount",
        "parity_byte": "ParityByte",
    }

    def __init__(self, sequence_indicator=None, total_count=None, parity_byte=None):  # noqa: E501
        """StructuredAppend - a model defined in Swagger"""  # noqa: E501

        self._sequence_indicator = None
        self._total_count = None
        self._parity_byte = None
        self.discriminator = None

        if sequence_indicator is not None:
            self.sequence_indicator = sequence_indicator
        if total_count is not None:
            self.total_count = total_count
        if parity_byte is not None:
            self.parity_byte = parity_byte

    @property
    def sequence_indicator(self):
        """Gets the sequence_indicator of this StructuredAppend.  # noqa: E501

        The index of the QR structured append mode barcode. Index starts from 0.  # noqa: E501

        :return: The sequence_indicator of this StructuredAppend.  # noqa: E501
        :rtype: int
        """
        return self._sequence_indicator

    @sequence_indicator.setter
    def sequence_indicator(self, sequence_indicator):
        """Sets the sequence_indicator of this StructuredAppend.

        The index of the QR structured append mode barcode. Index starts from 0.  # noqa: E501

        :param sequence_indicator: The sequence_indicator of this StructuredAppend.  # noqa: E501
        :type: int
        """

        self._sequence_indicator = sequence_indicator

    @property
    def total_count(self):
        """Gets the total_count of this StructuredAppend.  # noqa: E501

        QR structured append mode barcodes quantity. Max value is 16.  # noqa: E501

        :return: The total_count of this StructuredAppend.  # noqa: E501
        :rtype: int
        """
        return self._total_count

    @total_count.setter
    def total_count(self, total_count):
        """Sets the total_count of this StructuredAppend.

        QR structured append mode barcodes quantity. Max value is 16.  # noqa: E501

        :param total_count: The total_count of this StructuredAppend.  # noqa: E501
        :type: int
        """

        self._total_count = total_count

    @property
    def parity_byte(self):
        """Gets the parity_byte of this StructuredAppend.  # noqa: E501

        QR structured append mode parity data.  # noqa: E501

        :return: The parity_byte of this StructuredAppend.  # noqa: E501
        :rtype: int
        """
        return self._parity_byte

    @parity_byte.setter
    def parity_byte(self, parity_byte):
        """Sets the parity_byte of this StructuredAppend.

        QR structured append mode parity data.  # noqa: E501

        :param parity_byte: The parity_byte of this StructuredAppend.  # noqa: E501
        :type: int
        """

        self._parity_byte = parity_byte

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (item[0], item[1].to_dict()) if hasattr(item[1], "to_dict") else item,
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(StructuredAppend, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StructuredAppend):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
